import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { MerchantApply, MerchantApplyParam } from './model';
import { SERVER_API_URL } from '@/config/setting';

/**
 * 分页查询商户入驻申请
 */
export async function pageMerchantApply(params: MerchantApplyParam) {
  const res = await request.get<ApiResult<PageResult<MerchantApply>>>(
    SERVER_API_URL + '/system/merchant-apply/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商户入驻申请列表
 */
export async function listMerchantApply(params?: MerchantApplyParam) {
  const res = await request.get<ApiResult<MerchantApply[]>>(
    SERVER_API_URL + '/system/merchant-apply',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商户入驻申请
 */
export async function addMerchantApply(data: MerchantApply) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-apply',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商户入驻申请
 */
export async function updateMerchantApply(data: MerchantApply) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-apply',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商户入驻申请
 */
export async function removeMerchantApply(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-apply/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商户入驻申请
 */
export async function removeBatchMerchantApply(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    SERVER_API_URL + '/system/merchant-apply/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商户入驻申请
 */
export async function getMerchantApply(id: number) {
  const res = await request.get<ApiResult<MerchantApply>>(
    SERVER_API_URL + '/system/merchant-apply/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
